SDL_cpuinfo.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_cpuinfo.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_CACHELINE_SIZE 128

## Functions

int | SDL_GetNumLogicalCPUCores (void)
int | SDL_GetCPUCacheLineSize (void)
bool | SDL_HasAltiVec (void)
bool | SDL_HasMMX (void)
bool | SDL_HasSSE (void)
bool | SDL_HasSSE2 (void)
bool | SDL_HasSSE3 (void)
bool | SDL_HasSSE41 (void)
bool | SDL_HasSSE42 (void)
bool | SDL_HasAVX (void)
bool | SDL_HasAVX2 (void)
bool | SDL_HasAVX512F (void)
bool | SDL_HasARMSIMD (void)
bool | SDL_HasNEON (void)
bool | SDL_HasLSX (void)
bool | SDL_HasLASX (void)
int | SDL_GetSystemRAM (void)
size_t | SDL_GetSIMDAlignment (void)
int | SDL_GetSystemPageSize (void)

## Macro Definition Documentation

## SDL_CACHELINE_SIZE

#define SDL_CACHELINE_SIZE 128

# CategoryCPUInfo

CPU feature detection for SDL.

These functions are largely concerned with reporting if the system has access to various SIMD instruction sets, but also has other important info to share, such as system RAM size and number of logical CPU cores.

CPU instruction set checks, like SDL_HasSSE() and SDL_HasNEON(), are available on all platforms, even if they don't make sense (an ARM processor will never have SSE and an x86 processor will never have NEON, for example, but these functions still exist and will simply return false in these cases). A guess for the cacheline size used for padding.

Most x86 processors have a 64 byte cache line. The 64-bit PowerPC processors have a 128 byte cache line. We use the larger value to be generally safe.

Since
  This macro is available since SDL 3.2.0.

Definition at line 60 of file SDL_cpuinfo.h.

## Function Documentation

## SDL_GetCPUCacheLineSize()

int SDL_GetCPUCacheLineSize | ( | void |  | ) |

extern

Determine the L1 cache line size of the CPU.

This is useful for determining multi-threaded structure padding or SIMD prefetch sizes.

Returns
  the L1 cache line size of the CPU, in bytes.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetNumLogicalCPUCores()

int SDL_GetNumLogicalCPUCores | ( | void |  | ) |

extern

Get the number of logical CPU cores available.

Returns
  the total number of logical CPU cores. On CPUs that include technologies such as hyperthreading, the number of logical cores may be more than the number of physical cores.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSIMDAlignment()

size_t SDL_GetSIMDAlignment | ( | void |  | ) |

extern

Report the alignment this system needs for SIMD allocations.

This will return the minimum number of bytes to which a pointer must be aligned to be compatible with SIMD instructions on the current machine. For example, if the machine supports SSE only, it will return 16, but if it supports AVX-512F, it'll return 64 (etc). This only reports values for instruction sets SDL knows about, so if your SDL build doesn't have SDL_HasAVX512F(), then it might return 16 for the SSE support it sees and not 64 for the AVX-512 instructions that exist but SDL doesn't know about. Plan accordingly.

Returns
  the alignment in bytes needed for available, known SIMD instructions.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_aligned_alloc
  SDL_aligned_free

## SDL_GetSystemPageSize()

int SDL_GetSystemPageSize | ( | void |  | ) |

extern

Report the size of a page of memory.

Different platforms might have different memory page sizes. In current times, 4 kilobytes is not unusual, but newer systems are moving to larger page sizes, and esoteric platforms might have any unexpected size.

Note that this function can return 0, which means SDL can't determine the page size on this platform. It will not set an error string to be retrieved with SDL_GetError() in this case! In this case, defaulting to 4096 is often a reasonable option.

Returns
  the size of a single page of memory, in bytes, or 0 if SDL can't determine this information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.4.0.

## SDL_GetSystemRAM()

int SDL_GetSystemRAM | ( | void |  | ) |

extern

Get the amount of RAM configured in the system.

Returns
  the amount of RAM configured in the system in MiB.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_HasAltiVec()

bool SDL_HasAltiVec | ( | void |  | ) |

extern

Determine whether the CPU has AltiVec features.

This always returns false on CPUs that aren't using PowerPC instruction sets.

Returns
  true if the CPU has AltiVec features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_HasARMSIMD()

bool SDL_HasARMSIMD | ( | void |  | ) |

extern

Determine whether the CPU has ARM SIMD (ARMv6) features.

This is different from ARM NEON, which is a different instruction set.

This always returns false on CPUs that aren't using ARM instruction sets.

Returns
  true if the CPU has ARM SIMD features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasNEON

## SDL_HasAVX()

bool SDL_HasAVX | ( | void |  | ) |

extern

Determine whether the CPU has AVX features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has AVX features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasAVX2
  SDL_HasAVX512F

## SDL_HasAVX2()

bool SDL_HasAVX2 | ( | void |  | ) |

extern

Determine whether the CPU has AVX2 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has AVX2 features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasAVX
  SDL_HasAVX512F

## SDL_HasAVX512F()

bool SDL_HasAVX512F | ( | void |  | ) |

extern

Determine whether the CPU has AVX-512F (foundation) features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has AVX-512F features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasAVX
  SDL_HasAVX2

## SDL_HasLASX()

bool SDL_HasLASX | ( | void |  | ) |

extern

Determine whether the CPU has LASX (LOONGARCH SIMD) features.

This always returns false on CPUs that aren't using LOONGARCH instruction sets.

Returns
  true if the CPU has LOONGARCH LASX features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_HasLSX()

bool SDL_HasLSX | ( | void |  | ) |

extern

Determine whether the CPU has LSX (LOONGARCH SIMD) features.

This always returns false on CPUs that aren't using LOONGARCH instruction sets.

Returns
  true if the CPU has LOONGARCH LSX features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_HasMMX()

bool SDL_HasMMX | ( | void |  | ) |

extern

Determine whether the CPU has MMX features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has MMX features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_HasNEON()

bool SDL_HasNEON | ( | void |  | ) |

extern

Determine whether the CPU has NEON (ARM SIMD) features.

This always returns false on CPUs that aren't using ARM instruction sets.

Returns
  true if the CPU has ARM NEON features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_HasSSE()

bool SDL_HasSSE | ( | void |  | ) |

extern

Determine whether the CPU has SSE features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has SSE features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasSSE2()

bool SDL_HasSSE2 | ( | void |  | ) |

extern

Determine whether the CPU has SSE2 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has SSE2 features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasSSE
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasSSE3()

bool SDL_HasSSE3 | ( | void |  | ) |

extern

Determine whether the CPU has SSE3 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has SSE3 features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasSSE41()

bool SDL_HasSSE41 | ( | void |  | ) |

extern

Determine whether the CPU has SSE4.1 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has SSE4.1 features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE42

## SDL_HasSSE42()

bool SDL_HasSSE42 | ( | void |  | ) |

extern

Determine whether the CPU has SSE4.2 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  true if the CPU has SSE4.2 features or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41